
	.org	$fb00

	; Basic routines (paet1)

BCD_LowValue:
	.db	LOW(   10), LOW(   20), LOW(   40), LOW(   80)
	.db	LOW(  100), LOW(  200), LOW(  400), LOW(  800)
	.db	LOW( 1000), LOW( 2000), LOW( 4000), LOW( 8000)
	.db	LOW(10000), LOW(20000), LOW(40000)
BCD_HighValue:
	.db	             HIGH(  200), HIGH(  400), HIGH(  800)
	.db	HIGH( 1000), HIGH( 2000), HIGH( 4000), HIGH( 8000)
	.db	HIGH(10000), HIGH(20000), HIGH(40000)

	; converts a 1-byte value to binary coded decimal.
	; a: value
	; x:
	; y:
	; FNC_ARG .. FNC_ARG+2: result(big-endian)
	; use reg: a x y
	; use working variables
	;   FNC_ARG:  2-4
Math_ByteToBCD:
	sta	<FNC_ARG+4
	lda	#$40

	ldx	#2
	ldy	#5
	bne	_Math_ByteToBCD	; same as jmp

	; converts a 2-byte value to binary coded decimal.
	; a: value (low)
	; x: value (hight)
	; y:
	; FNC_ARG .. FNC_ARG+4: result(big-endian)
	; use reg: a x y
	; use working variables
	;   FNC_WORK: 0
	;   FNC_ARG:  0-4
Math_WordToBCD:
	sta	<FNC_ARG+4
	stx	<FNC_ARG+3
	lda	#$20
	sta	<FNC_ARG

	ldx	#0
	ldy	#9
.1:
	lda	<FNC_ARG+4
	sec
	sbc	BCD_LowValue+5,y
	sta	<FNC_WORK
	lda	<FNC_ARG+3
	sbc	BCD_HighValue,y
	bcc	.2
	sta	<FNC_ARG+3
	lda	<FNC_WORK
	sta	<FNC_ARG+4
.2:
	rol	<FNC_ARG,x
	bcc	.3
	inx
	lda	#$10
	sta	<FNC_ARG,x
.3:
	dey
	bpl	.1

	ldy	#4
	bne	_Math_ByteToBCD_Loop2	; same as jmp
_Math_ByteToBCD_Loop:
	inx
	lda	#$10
_Math_ByteToBCD:
	sta	<FNC_ARG,x
_Math_ByteToBCD_Loop2:
	lda	<FNC_ARG+4
	sec
	sbc	BCD_LowValue,y
	bcc	_Math_ByteToBCD_Skip
	sta	<FNC_ARG+4
_Math_ByteToBCD_Skip:
	rol	<FNC_ARG,x
	dey
	bcc	_Math_ByteToBCD_Loop2
	bpl	_Math_ByteToBCD_Loop
	rts

	; expand data to vram transfer buffer.
	; a: low address of parameter
	; x: high address of parameter
	; y:
	; parameter format
	;   +0 compression data length(byte)
	;   +1 flag
	;      $00: PPU address increment by 1
	;      $04: PPU address increment by 32
	;   +2 PPU address (LOW)
	;   +3 PPU address (HIGH)
	;   +4 compressed data address (LOW)
	;   +5 compressed data address (HIGH)
	; compressed data format
	;   00nnnnnn, value, ...
	;      copy n+1 bytes from compressed data to transfer buffer
	;   01nnnnnn
	;      copy n+1 bytes from position 1byte before in transfer buffer
	;   10nnnnnn
	;      copy n+1 bytes from position 2byte before in transfer buffer
	;   11nnnnnn
	;      copy n+1 bytes from position 4byte before in transfer buffer
	; use reg: a x y
	; use working variables
	;   FNC_WORK: 0-3
	;   FNC_ARG:  0-5
Vcmd_ExpandData:
	jsr	CopyToArg6
.retry:
	ldy	<VCMD_SIZE
	sty	<FNC_WORK+3
	cpy	#LOW(VCMD_LIMIT-VCMD_DATA)
	bcs	.abort

	lda	<FNC_ARG
	sta	<FNC_WORK+1
	lda	<FNC_ARG+1
	and	#$0f
	sta	VCMD_DATA+1,y
	lda	<FNC_ARG+2
	sta	VCMD_DATA+3,y
	lda	<FNC_ARG+3
	sta	VCMD_DATA+2,y
	ldx	Int+4,y		; x <= y + 4
	ldy	#0
.1:
	lda	[FNC_ARG+4],y
	iny
	sta	<FNC_WORK+2
	and	#$3f
	sta	<FNC_WORK
	eor	<FNC_WORK+2
	bne	.3

.2:
	lda	[FNC_ARG+4],y
	iny
	sta	VCMD_DATA,x
	inx
	dec	<FNC_WORK
	bpl	.2
	bmi	.5	; same as jmp
.3:
	sty	<FNC_WORK+2
	asl	a
	rol	a
	rol	a
	tay
	txa
	sec
	sbc	Bit-1,y
	tay
.4:
	lda	VCMD_DATA,y
	iny
	sta	VCMD_DATA,x
	inx
	dec	<FNC_WORK
	bpl	.4
	ldy	<FNC_WORK+2
.5:
	cpy	<FNC_WORK+1
	bcc	.1

	ldy	<FNC_WORK+3
	txa
;	sec
	sbc	Int+4,y
	sta	VCMD_DATA,y

	; retry if NMI interrupt is executed during data expansion
	cpy	<VCMD_SIZE
	bne	.retry
	stx	<VCMD_SIZE
.abort:
	rts

	; General-purpose constant table (part1)

	.org	$fbf8
Bit:
	.db	$01,$02,$04,$08,$10,$20,$40,$80

	.org	$fc00
Xcn:
	.db	$00,$10,$20,$30,$40,$50,$60,$70
	.db	$80,$90,$a0,$b0,$c0,$d0,$e0,$f0
	.db	$01,$11,$21,$31,$41,$51,$61,$71
	.db	$81,$91,$a1,$b1,$c1,$d1,$e1,$f1
	.db	$02,$12,$22,$32,$42,$52,$62,$72
	.db	$82,$92,$a2,$b2,$c2,$d2,$e2,$f2
	.db	$03,$13,$23,$33,$43,$53,$63,$73
	.db	$83,$93,$a3,$b3,$c3,$d3,$e3,$f3
	.db	$04,$14,$24,$34,$44,$54,$64,$74
	.db	$84,$94,$a4,$b4,$c4,$d4,$e4,$f4
	.db	$05,$15,$25,$35,$45,$55,$65,$75
	.db	$85,$95,$a5,$b5,$c5,$d5,$e5,$f5
	.db	$06,$16,$26,$36,$46,$56,$66,$76
	.db	$86,$96,$a6,$b6,$c6,$d6,$e6,$f6
	.db	$07,$17,$27,$37,$47,$57,$67,$77
	.db	$87,$97,$a7,$b7,$c7,$d7,$e7,$f7
	.db	$08,$18,$28,$38,$48,$58,$68,$78
	.db	$88,$98,$a8,$b8,$c8,$d8,$e8,$f8
	.db	$09,$19,$29,$39,$49,$59,$69,$79
	.db	$89,$99,$a9,$b9,$c9,$d9,$e9,$f9
	.db	$0a,$1a,$2a,$3a,$4a,$5a,$6a,$7a
	.db	$8a,$9a,$aa,$ba,$ca,$da,$ea,$fa
	.db	$0b,$1b,$2b,$3b,$4b,$5b,$6b,$7b
	.db	$8b,$9b,$ab,$bb,$cb,$db,$eb,$fb
	.db	$0c,$1c,$2c,$3c,$4c,$5c,$6c,$7c
	.db	$8c,$9c,$ac,$bc,$cc,$dc,$ec,$fc
	.db	$0d,$1d,$2d,$3d,$4d,$5d,$6d,$7d
	.db	$8d,$9d,$ad,$bd,$cd,$dd,$ed,$fd
	.db	$0e,$1e,$2e,$3e,$4e,$5e,$6e,$7e
	.db	$8e,$9e,$ae,$be,$ce,$de,$ee,$fe
	.db	$0f,$1f,$2f,$3f,$4f,$5f,$6f,$7f
	.db	$8f,$9f,$af,$bf,$cf,$df,$ef,$ff

	.org	$fd00

	; Basic routines (paet2)

	; transfer data into the vram over multiple frames.
	; expand data to vram transfer buffer
	; a: low address of parameter
	; x: high address of parameter
	; y:
	; Arrange multiple parameters of Vcmd_ExtractData.
	; The definition added to the flag in the transfer 
	; parameter is as follows.
	; 0x80:Suspends data expansion into the vram transfer 
	;      buffer and returns. (z flag is 0)
	; 0xc0:Finish a data expansion into the vram transfer 
	;      buffer and returns. (z flag is 1)
	; If suspended the data expansion, resume the data 
	; expansion into vram transfer buffer by call Vcmd_sequenceData.
	; By combining with Yeild_Eq, transfer data into the 
	; vram over multiple frames.
	; use reg: a x y
	; use working variables
	;   FNC_WORK: 0-5
	;   FNC_ARG:  0-5
Vcmd_SequenceData:
	ldy	VCMD_SEQ+1
	beq	.1
	lda	VCMD_SEQ
	ldx	VCMD_SEQ+1
.1:
	sta	<FNC_WORK+4
	stx	<FNC_WORK+5
	jsr	Vcmd_ExpandData

	lda	<FNC_WORK+4
	ldx	<FNC_WORK+5
	clc
	adc	#6
	bcc	.2
	inx
.2:
	bit	<FNC_ARG+1	; See the parameters expanded to FNC_ARG
				; by Vcmd_ExtractData
	bpl	.1

	cpx	#0		; clear z flag
	bvc	.9
	ldx	#$00
	txa
.9:
	sta	VCMD_SEQ
	stx	VCMD_SEQ+1
	rts

	; copy to FNC_ARG from parameter
	; a: low address of parameter
	; x: high address of parameter
	; y: parameter size
	; use reg: a x y
	; use working variables
	;   FNC_WORK: none
	;   FNC_ARG:  none
CopyToArg6:
	ldy	#6
CopyToArg:
	sta	<FNC_ARG
	stx	<FNC_ARG+1
	dey
.1:
	lda	[FNC_ARG],y
	tax
	dey
	lda	[FNC_ARG],y
	stx	<FNC_ARG+1,y
	sta	FNC_ARG,y
	dey
	bpl	.1
	rts

	.if	OPT_JOYPAD_DMC_MEASURES
Joypad:
	; get joypad status
	lda	#$01
	sta	<JOYPAD+1
	sta	$4016
	lsr	a		; same as lda $00
	sta	$4016
.1:
	lda	$4016
	and	#$03
	cmp	#1
	rol	<JOYPAD
	lda	$4017
	and	#$03
	cmp	#1
	rol	<JOYPAD+1
	bcc	.1
	rts
	.endif

	; xorshift pseudo-random number (16bit)
	; xs ^= xs << 7
	; xs ^= xs >> 9
	; xs ^= xs << 8
	; use reg: a
	; use working variables
	;   FNC_WORK: none
	;   FNC_ARG:  none
Rand:
	lda	<RAND+1
	lsr	a
	lda	<RAND
	ror	a
	eor	<RAND+1
	sta	<RAND+1
	ror	a
	eor	<RAND
	sta	<RAND
	eor	<RAND+1
	sta	<RAND+1
Rand_Ret:
	rts

FrameTask:
	; update state of joypad
	.if	OPT_JOYPAD_DMC_MEASURES
.1:
	jsr	Joypad
	ldx	<JOYPAD
	jsr	Joypad
	cpx	<JOYPAD
	bne	.1
	.else
	lda	#$01
	sta	<JOYPAD+1
	sta	$4016
	lsr	a		; same as lda $00
	sta	$4016
.1:
	lda	$4016
	and	#$03
	cmp	#1
	rol	<JOYPAD
	lda	$4017
	and	#$03
	cmp	#1
	rol	<JOYPAD+1
	bcc	.1
	.endif

	; update random number
	jsr	Rand

	; update sound driver
	jsr	Fssql_Update

	; call user defined frame task
	lda	FRM_FNC+1
	beq	Rand_Ret	; use ret instruction of Rand routine.
	jmp	[FRM_FNC]

Reset:
	; disable irq
	sei

	; screen off
	lda	#$00
	sta	$2000
	sta	$2001

	; initialize stack
	cld
	ldx	#LOW(STK_BASE-1)
	txs

	; DMC interrupt setting
;	lda	#$00
	sta	$4010

	; wait a VBlamk
;	lda	#$00
.1:
	bit	$2002
	bpl	.1

	; Erase working memory
	; The current method is 1.5 times slower than the case 
	; of arranging sta $ 0000, x .. sta $ 0700, x, 
	; but it is adopted because the program size becomes 
	; smaller and the area not to be erased can be set by 
	; adjusting the initial value of y.
	; Since the value of FNC_WORK+1 is 0 when initializing 
	; the zero page, writing 0 to FNC_WORK+1 does not cause 
	; any problems.
;	lda	#$00
	ldx	#7
	sta	<FNC_WORK
	stx	<FNC_WORK+1
	tay
.2:
	dey
	sta	[FNC_WORK],y
	bne	.2
	dec	<FNC_WORK+1
	bpl	.2

	; initialize pseudo-random number
;	ldx	#7
	stx	<RAND

	; wait a VBlamk
.3:
	bit	$2002
	bpl	.3

	; initialize of sound driver
	jsr	Fssql_Init

	; initialize of task control
	lda	#$4c		; jmp	$xxxx
	sta	IRQ_FNC-1
	sta	NMI_FNC-1
	sta	<USR_FNC-1

	jmp	Reset2

	; Routines for waiting for VBlank
	; Yeild          Transition from user task to waiting for VBlank.
	;                Resume from the next instruction in the transition.
	; Yeild_ReEntry  Transition from user task to waiting for VBlank.
	;                Resume from the previously resumed instruction.
	; Yeild_Eq       If z flag is 0, execute Yeild_ReEntry.
	;                If z flag is 1, execute Yeild.
	; Yeild_SetEntry Set a resume position for user task.
	;                not transition to waiting for VBlank.
	;                continue user task.
Yeild_SetEntry:
	.db	$a0	; ldy #$a0
Yeild:
	ldy	#$18	; $a0 clc
	clc
	pla
	adc	#1
	sta	TSK_FNC
	pla
	adc	#0
	sta	TSK_FNC+1
	tya
	bpl	_Yeild_Jmp

	jmp	[TSK_FNC]

Yeild_Eq:
	beq	Yeild
Yeild_ReEntry:
	pla
	pla
_Yeild_Jmp:
	jmp	_ReEntry

	; General-purpose constant table (part2)

	.org	$fdf0

	.db	$f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7
	.db	$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff

	.org	$fe00
Int:
	.db	$00,$01,$02,$03,$04,$05,$06,$07
	.db	$08,$09,$0a,$0b,$0c,$0d,$0e,$0f
	.db	$10,$11,$12,$13,$14,$15,$16,$17
	.db	$18,$19,$1a,$1b,$1c,$1d,$1e,$1f
	.db	$20,$21,$22,$23,$24,$25,$26,$27
	.db	$28,$29,$2a,$2b,$2c,$2d,$2e,$2f
	.db	$30,$31,$32,$33,$34,$35,$36,$37
	.db	$38,$39,$3a,$3b,$3c,$3d,$3e,$3f
	.db	$40,$41,$42,$43,$44,$45,$46,$47
	.db	$48,$49,$4a,$4b,$4c,$4d,$4e,$4f
	.db	$50,$51,$52,$53,$54,$55,$56,$57
	.db	$58,$59,$5a,$5b,$5c,$5d,$5e,$5f
	.db	$60,$61,$62,$63,$64,$65,$66,$67
	.db	$68,$69,$6a,$6b,$6c,$6d,$6e,$6f
	.db	$70,$71,$72,$73,$74,$75,$76,$77
	.db	$78,$79,$7a,$7b,$7c,$7d,$7e,$7f
	.db	$80,$81,$82,$83,$84,$85,$86,$87
	.db	$88,$89,$8a,$8b,$8c,$8d,$8e,$8f
	.db	$90,$91,$92,$93,$94,$95,$96,$97
	.db	$98,$99,$9a,$9b,$9c,$9d,$9e,$9f
	.db	$a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7
	.db	$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af
	.db	$b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7
	.db	$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf
	.db	$c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7
	.db	$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf
	.db	$d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7
	.db	$d8,$d9,$da,$db,$dc,$dd,$de,$df
	.db	$e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7
	.db	$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef
	.db	$f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7
	.db	$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff

	.db	$00,$01,$02,$03,$04,$05,$06,$07
	.db	$08,$09,$0a,$0b,$0c,$0d,$0e,$0f

	.org	$ff10

Reset2:
	; setup a entry of user task
	lda	#LOW(User)
	sta	TSK_FNC
	lda	#HIGH(User)
	sta	TSK_FNC+1

	; screen on
	lda	#$88
	sta	<PPU_REG1
	sta	$2000

_ReEntry:
;		ldx	#$1e
;		stx	$2001

	lda	<SYS_CNT
	cli
_MainLoop:
	cmp	<SYS_CNT
	beq	_MainLoop

;		inx		; same as ldx #$1f
;		stx	$2001

	; call frame task
	jsr	FrameTask

	; return to user task
	jmp	[TSK_FNC]

VBlank:				; total:2273 clk
	pha			; 3
	stx	<SUS_NMI_X	; 3
	sty	<SUS_NMI_Y	; 3

	; reset a address latch for $2005/$2006
	lda	$2002		; 4

	; transport a sprite attribute data
	lda	<SPR_UPD	; 3
	beq	.1		; 2/3
	lda	#$00		; 2
	sta	$2003		; 4
	ldx	#HIGH(SPR_DATA)	; 2
	stx	$4014		; 514 (+540/+19)
.1:
	; transfer data to VRAM.
	; use SPR_UPD as a save area for SP during transfer to VRAM.
	ldx	<VCMD_SIZE		; 3
;	lda	#$00
	sta	VCMD_DATA,x		; 4
	tsx				; 2
	stx	<SPR_UPD		; 3
	ldx	#LOW(VCMD_DATA-1)	; 2
	txs				; 2 (+16)

	pla			; 4
	beq	.5		; 3
.2:
	lsr	a		; 2
	tax			; 2
	pla			; 4
	ora	<PPU_REG1	; 3
	sta	$2000		; 4
	pla			; 4
	sta	$2006		; 4
	pla			; 4
	sta	$2006		; 4
	bcc	.3		; 3 (+41)
	pla			; 4
	sta	$2007		; 4
	txa			; 2
	beq	.4		; 3 (+13)
.3:
	pla			; 4
	sta	$2007		; 4
	pla			; 4
	sta	$2007		; 4
	dex			; 2
	bne	.3		; 3 (+21)
.4:
	pla			; 4
	bne	.2		; 3
.5:
	ldx	<SPR_UPD	; 3
	txs			; 2
;	lda	#$00
	sta	<VCMD_SIZE	; 3

	; clear a flag to transport a sprite attribute data
	sta	<SPR_UPD

	; update system counter
	inc	<SYS_CNT

	; call user defined nmi task
	lda	NMI_FNC+1
	beq	.7
	jsr	NMI_FNC-1
.7:

	; setup scroll register
	lda	<SCROLL_X
	sta	$2005
	lda	<SCROLL_Y
	sta	$2005

	; setup PPU register
	lda	<PPU_REG1
	sta	$2000

	; update APU register
	jsr	Fssql_Reflect

	; When the user task is being executed (ip! = $ ffxx), 
	; the user task is suspended and the frame task is executed.
	; After the frame task ends, return to the suspended user task.
	tsx
	lda	$0104,x
	cmp	#$ff
	beq	.10
;	inc	<$b0	; count a slowdown

	; save working variables
	ldx	#$13
.8:
	lda	<FNC_WORK,x
	sta	SUS_WORK,x
	dex
	bpl	.8

	; call frame task
	cli
	jsr	FrameTask

	; restore working variables
	ldx	#$13
.9:
	lda	SUS_WORK,x
	sta	<FNC_WORK,x
	dex
	bpl	.9

.10:
	ldy	<SUS_NMI_Y
	ldx	<SUS_NMI_X
	pla
	rti

Irq:
	pha			; 3
	stx	<SUS_IRQ_X		; 3
	sty	<SUS_IRQ_Y		; 3

	; call user defined irq task
	lda	IRQ_FNC+1	; 4
	beq	.1		; 2
	jsr	IRQ_FNC-1	; 6+3
.1:

	ldy	<SUS_IRQ_Y
	ldx	<SUS_IRQ_X
	pla
	rti

	; interrupt vector
	.org	$fffa
	.dw	VBlank
	.dw	Reset
	.dw	Irq

